"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const constants_1 = __importDefault(require("./constants"));
const chalk_1 = __importDefault(require("chalk"));
class Spinner {
    interval_id;
    counter;
    message;
    constructor(message) {
        this.counter = 0;
        this.message = message;
    }
    start() {
        if (this.interval_id !== undefined) {
            console.error();
            return;
        }
        const interval = constants_1.default.SPINNER.BOUNCING_BALL.INTERVAL;
        const frames = constants_1.default.SPINNER.BOUNCING_BALL.FRAMES;
        this.interval_id = setInterval(() => {
            process.stdout.write(chalk_1.default.greenBright(`${frames[this.counter]}`) + ` ${this.message}\r`);
            this.counter = (this.counter + 1) % frames.length;
        }, interval);
    }
    stop() {
        if (this.interval_id === undefined) {
            console.error("[Error] Spinner is not spinning yet.");
            return;
        }
        clearInterval(this.interval_id);
        this.interval_id = undefined;
        this.counter = 0;
    }
}
;
exports.default = Spinner;
